<?php

if (file_exists('../../../init.php')) {
    include_once('../../../init.php');
} else {
    include_once('../../../dbconnect.php');
    include_once('../../../includes/functions.php');
}

include('../../../includes/gatewayfunctions.php');
include('../../../includes/invoicefunctions.php');

$gatewaymodule = 'rukassa';
$GATEWAY = getGatewayVariables($gatewaymodule);

if ( isset($_REQUEST['order_id']) && isset($_SERVER['HTTP_SIGNATURE'])) {
	
	$signature = hash_hmac('sha256', $_REQUEST['id'] . '|' . $_REQUEST['createdDateTime'] . '|' . $_REQUEST['amount'], $GATEWAY['api_key']);
	
    $log_text = "--------------------------------------------------------\n";
    foreach ($_REQUEST as $name => $value) {
        $log_text .= "{$name}: {$value}\n";
    }
    if ( ! empty($GATEWAY['RuKassa_logfile'])){

        file_put_contents($_SERVER['DOCUMENT_ROOT'] . $GATEWAY['RuKassa_logfile'], $log_text, FILE_APPEND);
    }

    if ((string)$_SERVER['HTTP_SIGNATURE'] !== (string)$signature){

        if (!empty($GATEWAY['RuKassa_email_error'])){

            $to = $GATEWAY['RuKassa_email_error'];
            $subject = "Ошибка оплаты";
            $message = "Не удалось провести платёж через систему RuKassa по следующим причинам:\n\n";
            $message .= " - Не совпадают цифровые подписи\n";
            $message .= "\n" . $log_text;
            $headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\nContent-type: text/plain; charset=utf-8 \r\n";
            mail($to, $subject, $message, $headers);
        }

        exit ($_REQUEST['order_id'] . ' | error signature');
    }

	if ($_REQUEST['in_amount'] < $_REQUEST['amount']){

        if (!empty($GATEWAY['RuKassa_email_error'])){

            $to = $GATEWAY['RuKassa_email_error'];
            $subject = "Ошибка оплаты";
            $message = "Не удалось провести платёж через систему RuKassa по следующим причинам:\n\n";
            $message .= " - Оплаченная сумма, меньше необходимой\n";
            $message .= "\n" . $log_text;
            $headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\nContent-type: text/plain; charset=utf-8 \r\n";
            mail($to, $subject, $message, $headers);
        }

        exit ($_REQUEST['order_id'] . ' | error not enough amount');
    }
	
    // проверка принадлежности ip списку доверенных ip

    $valid_ip = false;
    $sIP = str_replace(' ', '', $GATEWAY['rukassa_ipfilter']);
    $array_IP = explode(',', $sIP);
    if (isset($_SERVER["HTTP_X_REAL_IP"])) {
        $cur_ip = $_SERVER["HTTP_X_REAL_IP"];
    } else {
        $cur_ip = $_SERVER["REMOTE_ADDR"];
    }
    if (in_array($cur_ip, $array_IP)) {
        $valid_ip = true;
    }


    if ((string)$_SERVER['HTTP_SIGNATURE'] === (string)$signature && $valid_ip){

        addInvoicePayment($_REQUEST['order_id'], $GATEWAY['shop_id'], $payed, '', $gatewaymodule);
        logTransaction($GATEWAY['name'], $_REQUEST, 'Successful');
        exit ('YES');
    } else {

        logTransaction($GATEWAY['name'], $event, 'Unsuccessful');

        exit ($_REQUEST['order_id'] . ' | error | ' . !$valid_ip ? 'ip' : 'signature');
    }
} else {
    exit ($_REQUEST['order_id'] . ' | error | no parameters');
}